# Couenne::Domain Class Reference

Define a dynamic point+bounds, with a way to save and restore previous points+bounds through a LIFO structure. More...

`#include <CouenneDomain.hpp>`

List of all members.

## Public Member Functions
| Domain ()
| basic constructor
| Domain (const Domain &src)
| copy constructor
| ~Domain ()
| destructor
void | push (int dim, CouNumber *x, CouNumber *lb, CouNumber *ub, bool copy=true)
| save current point and start using another
void | push (int dim, const CouNumber *x, const CouNumber *lb, const CouNumber *ub, bool copy=true)
| save current point and start using another
void | push (const OsiSolverInterface *si, OsiCuts *cs=NULL, bool copy=true)
| save current point and start using another -- retrieve information from solver interface and from previous column cuts
void | push (const DomainPoint &dp, bool copy=true)
| save current point and start using another
void | pop ()
| restore previous point
DomainPoint * | current ()
| return current point
CouNumber & | x (register int index)
| current variable
CouNumber & | lb (register int index)
| current lower bound
CouNumber & | ub (register int index)
| current upper bound
CouNumber * | x ()
| return current variable vector
CouNumber * | lb ()
| return current lower bound vector
CouNumber * | ub ()
| return current upper bound vector
## Protected Attributes
DomainPoint * | point_
| current point
std::stack< DomainPoint * > | domStack_
| stack of saved points

## Detailed Description

Define a dynamic point+bounds, with a way to save and restore previous points+bounds through a LIFO structure.

Definition at line 104 of file CouenneDomain.hpp.

## Constructor & Destructor Documentation

Couenne::Domain::Domain | ( |  | ) | `[inline]`

basic constructor

Definition at line 114 of file CouenneDomain.hpp.

Couenne::Domain::Domain | ( | const Domain & | src | ) | `[inline]`

copy constructor

Definition at line 117 of file CouenneDomain.hpp.

References point_.

Couenne::Domain::~Domain | ( |  | ) |

destructor

## Member Function Documentation

void Couenne::Domain::push | ( | int | dim,
|  | CouNumber * | x,
|  | CouNumber * | lb,
|  | CouNumber * | ub,
|  | bool | copy = `true` |
| ) |  |  |

save current point and start using another

void Couenne::Domain::push | ( | int | dim,
|  | const CouNumber * | x,
|  | const CouNumber * | lb,
|  | const CouNumber * | ub,
|  | bool | copy = `true` |
| ) |  |  |

save current point and start using another

void Couenne::Domain::push | ( | const OsiSolverInterface * | si,
|  | OsiCuts * | cs = `NULL`,
|  | bool | copy = `true` |
| ) |  |  |

save current point and start using another -- retrieve information from solver interface and from previous column cuts

void Couenne::Domain::push | ( | const DomainPoint & | dp,
|  | bool | copy = `true` |
| ) |  |  |

save current point and start using another

void Couenne::Domain::pop | ( |  | ) |

restore previous point

DomainPoint* Couenne::Domain::current | ( |  | ) | `[inline]`

return current point

Definition at line 154 of file CouenneDomain.hpp.

References point_.

CouNumber& Couenne::Domain::x | ( | register int | index | ) | `[inline]`

current variable

Definition at line 156 of file CouenneDomain.hpp.

References point_, and x().

Referenced by Couenne::CouenneProblem::X(), and x().

CouNumber& Couenne::Domain::lb | ( | register int | index | ) | `[inline]`

current lower bound

Definition at line 157 of file CouenneDomain.hpp.

References lb(), and point_.

Referenced by Couenne::CouenneProblem::Lb(), and lb().

CouNumber& Couenne::Domain::ub | ( | register int | index | ) | `[inline]`

current upper bound

Definition at line 158 of file CouenneDomain.hpp.

References point_, and ub().

Referenced by Couenne::CouenneProblem::Ub(), and ub().

CouNumber* Couenne::Domain::x | ( |  | ) | `[inline]`

return current variable vector

Definition at line 160 of file CouenneDomain.hpp.

References point_, and x().

Referenced by x().

CouNumber* Couenne::Domain::lb | ( |  | ) | `[inline]`

return current lower bound vector

Definition at line 161 of file CouenneDomain.hpp.

References lb(), and point_.

Referenced by lb().

CouNumber* Couenne::Domain::ub | ( |  | ) | `[inline]`

return current upper bound vector

Definition at line 162 of file CouenneDomain.hpp.

References point_, and ub().

Referenced by ub().

## Member Data Documentation

DomainPoint* Couenne::Domain::point_`[protected]`

current point

Definition at line 108 of file CouenneDomain.hpp.

Referenced by current(), Domain(), lb(), ub(), and x().

std::stack<DomainPoint *> Couenne::Domain::domStack_`[protected]`

stack of saved points

Definition at line 109 of file CouenneDomain.hpp.

The documentation for this class was generated from the following file:

- CouenneDomain.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines